within OpenWPL;

model MOC "A global model in which MOC parameters are stored"

//creating an array where time step will be stored for a unspecified dimension
//Real time_step[2];

/*
parameter Integer nPipes = 2;
input Real dx_array[nPipes];
Real dx_min=min(dx_array);
*/

// dt = dx1/a1 = (L1/N1)/a1 = (L2/N2)/a2

parameter Integer T = 100 "Simulation time"
  annotation(Dialog(tab = "Simulation setup"));
  
parameter Integer N = 4 "Simulation steps"
  annotation(Dialog(tab = "Simulation setup"));

parameter Integer H_reservoir = 10 "Hydraulic head at the reservoir"
  annotation(Dialog(tab = "Simulation setup"));
  
parameter Integer H_sink = 0 "Hydraulic head at the sink"
  annotation(Dialog(tab = "Simulation setup"));  
  
equation

annotation(
    defaultComponentName="moc",
    defaultComponentPrefixes="inner",
    missingInnerMessage="
Your model is using an outer \"moc\" component but
an inner \"moc\" component is not defined.
For simulation drag OpenWPL.MOC into your model
to specify system properties.",
    Diagram(graphics = {Rectangle(lineColor = {0, 85, 255}, extent = {{-100, 100}, {100, -100}}), Line(origin = {0.01, 11.61}, points = {{-68.0076, -47.6107}, {-4.0076, 48.3893}, {67.9924, -47.6107}}, thickness = 1.5), Text(origin = {-70, -60}, extent = {{18, -12}, {-14, 6}}, textString = "A"), Text(origin = {72, -58}, extent = {{18, -12}, {-14, 6}}, textString = "B"), Text(origin = {-6, 82}, extent = {{20, -12}, {-14, 6}}, textString = "P"), Text(origin = {-60, 20}, extent = {{18, -12}, {-14, 6}}, textString = "C+"), Text(origin = {58, 18}, extent = {{20, -12}, {-14, 6}}, textString = "C-")}, coordinateSystem(initialScale = 0.1)),
    Icon(graphics = {Text(origin = {-6, 82}, extent = {{20, -12}, {-14, 6}}, textString = "P"), Line(origin = {0.01, 11.61}, points = {{-68.0076, -47.6107}, {-4.0076, 48.3893}, {67.9924, -47.6107}}, thickness = 1.5), Text(origin = {72, -58}, extent = {{18, -12}, {-14, 6}}, textString = "B"), Text(origin = {-70, -60}, extent = {{18, -12}, {-14, 6}}, textString = "A"), Rectangle(lineColor = {0, 85, 255}, extent = {{-100, 100}, {100, -100}}), Text(lineColor = {0, 0, 255}, extent = {{-150, 150}, {150, 110}}, textString = "%name")}, coordinateSystem(initialScale = 0.1)));
end MOC;
