within OpenWPL.Rigs;

model Open_Francis_Loop

  extends OpenWPL.Icons.Francis;
  OpenHPL.Waterway.Reservoir UPPER_TANK(H_r = 4.1391, Input_level = false, L = 2, alpha = 0, w = 2)  annotation(
    Placement(visible = true, transformation(origin = {-238, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_1(D_i = 0.5, H = 1.365, L = 1.365)  annotation(
    Placement(visible = true, transformation(origin = {-160, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp(duration = 0, height = -0.45, offset = 0.5, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {880, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.ElectroMech.Turbines.Turbine FRANCIS_TURBINE(C_v = 0.5, ConstEfficiency = true, H_n = 12, ValveCapacity = true, Vdot_n = 0.2)  annotation(
    Placement(visible = true, transformation(origin = {1002, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-280, 180}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir SWAMP(H_r = 1)  annotation(
    Placement(visible = true, transformation(origin = {1036, -242}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_LEFT_BEND(D_i = 0.5, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {-202, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_DOWNWARDS_BEND(D_i = 0.5, K_L = 1)  annotation(
    Placement(visible = true, transformation(origin = {-122, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_2_CONICAL_DIFFUSER(D_i = 0.5, D_o = 0.6, H = 0.535, L = 535)  annotation(
    Placement(visible = true, transformation(origin = {-94, 130}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe INLET_PIPE_2_MIDDLE_SECTION(D_i = 0.6, H = 1.763, L = 1.763)  annotation(
    Placement(visible = true, transformation(origin = {-94, 90}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe INLET_PIPE_2_CONICAL_NOZZLE(D_i = 0.6, D_o = 0.4, H = 0.880, L = 0.880)  annotation(
    Placement(visible = true, transformation(origin = {-94, 36}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Fitting FLOWMETER_1_INLET_FITTING(D_i = 0.4, D_o = 0.365)  annotation(
    Placement(visible = true, transformation(origin = {-94, -20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe FLOWMETER_1(D_i = 0.365, H = 0.6, L = 0.6)  annotation(
    Placement(visible = true, transformation(origin = {-94, -66}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Fitting FLOWMETER_1_OUTLET_FITTING(D_i = 0.365, D_o = 0.4)  annotation(
    Placement(visible = true, transformation(origin = {-94, -124}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe INLET_PIPE_3_CONICAL_DIFFUSER(D_i = 0.4, D_o = 0.6, H = 1.920, L = 1.920)  annotation(
    Placement(visible = true, transformation(origin = {-94, -182}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe INLET_PIPE_3_OULET_SECTION(D_i = 0.6, H = 1.330, L = 1.330)  annotation(
    Placement(visible = true, transformation(origin = {-94, -242}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_4_BEND(D_i = 0.6, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {-84, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_4_INLET(D_i = 0.6, H = 0.698, L = 0.698)  annotation(
    Placement(visible = true, transformation(origin = {-94, -298}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.Pipe INLET_PIPE_4_OUTLET(D_i = 0.6, H = 0, L = 0.698)  annotation(
    Placement(visible = true, transformation(origin = {-40, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_1_FITTING_INLET(D_i = 0.6, D_o = 0.602)  annotation(
    Placement(visible = true, transformation(origin = {0, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_1_FITTING_OUTLET(D_i = 0.602, D_o = 0.6)  annotation(
    Placement(visible = true, transformation(origin = {94, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe VALVE_1(D_i = 0.602, H = 0, L = 0.137)  annotation(
    Placement(visible = true, transformation(origin = {50, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_5(D_i = 0.6, H = 0, L = 1.423)  annotation(
    Placement(visible = true, transformation(origin = {148, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_6_INLET(D_i = 0.6, H = 0, L = 0.78)  annotation(
    Placement(visible = true, transformation(origin = {200, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_6_BEND(D_i = 0.5, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {262, -350}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_6_OUTLET(D_i = 0.6, H = 0, L = 0.494)  annotation(
    Placement(visible = true, transformation(origin = {272, -310}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  OpenHPL.Waterway.Pipe VALVE_2(D_i = 0.602, H = 0, L = 0.137) annotation(
    Placement(visible = true, transformation(origin = {272, -224}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  OpenHPL.Waterway.Fitting VALVE_2_FITTING_OUTLET(D_i = 0.602, D_o = 0.6) annotation(
    Placement(visible = true, transformation(origin = {272, -176}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  OpenHPL.Waterway.Fitting VALVE_2_FITTING_INLET(D_i = 0.6, D_o = 0.602) annotation(
    Placement(visible = true, transformation(origin = {272, -266}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  OpenHPL.Waterway.Pipe PRESSURE_TANK_INLET(D_i = 0.6, H = 0, L = 1.829)  annotation(
    Placement(visible = true, transformation(origin = {272, -122}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  OpenHPL.Waterway.SurgeTank PRESSURE_TANK(D = 2.175,D_t = 0.6,H = 5, L = 2, L_t = 0.2, SurgeTankType = OpenHPL.Types.SurgeTank.STThrottleValve, Vdot_0 = 19, h_0 = 2)  annotation(
    Placement(visible = true, transformation(origin = {290, -88}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe TOKKE_PIPE_BEND(D_i = 0.6, K_L = 0.2)  annotation(
    Placement(visible = true, transformation(origin = {324, -88}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe TOKKE_PIPE(D_i = 0.6, H = 0.1, L = 2.112)  annotation(
    Placement(visible = true, transformation(origin = {358, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_3_FITTING_INLET(D_i = 0.6, D_o = 0.602) annotation(
    Placement(visible = true, transformation(origin = {402, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe VALVE_3(D_i = 0.602, H = 0, L = 0.137) annotation(
    Placement(visible = true, transformation(origin = {440, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_3_FITTING_OUTLET(D_i = 0.602, D_o = 0.566) annotation(
    Placement(visible = true, transformation(origin = {484, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON1(D_i = 0.566, D_o = 0.250, H = 0, L = 2.833)  annotation(
    Placement(visible = true, transformation(origin = {524, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting FLOWMETER_2_OUTLET_FITTING(D_i = 0.249, D_o = 0.25) annotation(
    Placement(visible = true, transformation(origin = {646, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting FLOWMETER_2_INLET_FITTING(D_i = 0.25, D_o = 0.249) annotation(
    Placement(visible = true, transformation(origin = {566, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe FLOWMETER_2(D_i = 0.249, H = 0, L = 0.4) annotation(
    Placement(visible = true, transformation(origin = {606, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON2(D_i = 0.25, D_o = 0.4, H = 0, L = 1.492)  annotation(
    Placement(visible = true, transformation(origin = {692, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON3(D_i = 0.4, D_o = 0.35, H = 0, L = 0.611)  annotation(
    Placement(visible = true, transformation(origin = {732, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe KOBLING_INLET(D_i = 0.35, H = 0, L = 0.185)  annotation(
    Placement(visible = true, transformation(origin = {778, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting KOBLING_INLET_FITTING(D_i = 0.35, D_o = 0.38)  annotation(
    Placement(visible = true, transformation(origin = {822, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe KOBLING_OUTLET(D_i = 0.38, H = 0, L = 0.133)  annotation(
    Placement(visible = true, transformation(origin = {868, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON4(D_i = 0.35, D_o = 0.333, H = 0, L = 0.39)  annotation(
    Placement(visible = true, transformation(origin = {950, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_350(D_i = 0.35, H = 0, L = 3.934) annotation(
    Placement(visible = true, transformation(origin = {906, -110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step(height = 0, offset = 10, startTime = 25) annotation(
    Placement(visible = true, transformation(origin = {-280, 146}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(INLET_PIPE_1_LEFT_BEND.o, INLET_PIPE_1.i) annotation(
    Line(points = {{-192, 140}, {-170, 140}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1.o, INLET_PIPE_1_DOWNWARDS_BEND.i) annotation(
    Line(points = {{-150, 140}, {-132, 140}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_MIDDLE_SECTION.i, INLET_PIPE_2_CONICAL_DIFFUSER.o) annotation(
    Line(points = {{-94, 100}, {-94, 120}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_NOZZLE.i, INLET_PIPE_2_MIDDLE_SECTION.o) annotation(
    Line(points = {{-94, 46}, {-94, 80}}, color = {28, 108, 200}));
  connect(FLOWMETER_1.i, FLOWMETER_1_INLET_FITTING.o) annotation(
    Line(points = {{-94, -56}, {-94, -30}}, color = {28, 108, 200}));
  connect(FLOWMETER_1_OUTLET_FITTING.i, FLOWMETER_1.o) annotation(
    Line(points = {{-94, -114}, {-94, -76}}, color = {28, 108, 200}));
  connect(INLET_PIPE_3_CONICAL_DIFFUSER.i, FLOWMETER_1_OUTLET_FITTING.o) annotation(
    Line(points = {{-94, -172}, {-94, -134}}, color = {28, 108, 200}));
  connect(INLET_PIPE_3_OULET_SECTION.i, INLET_PIPE_3_CONICAL_DIFFUSER.o) annotation(
    Line(points = {{-94, -232}, {-94, -192}}, color = {28, 108, 200}));
  connect(INLET_PIPE_4_INLET.i, INLET_PIPE_3_OULET_SECTION.o) annotation(
    Line(points = {{-94, -288}, {-94, -252}}, color = {28, 108, 200}));
  connect(INLET_PIPE_4_INLET.o, INLET_PIPE_4_BEND.i) annotation(
    Line(points = {{-94, -308}, {-94, -350}}, color = {28, 108, 200}));
  connect(INLET_PIPE_4_BEND.o, INLET_PIPE_4_OUTLET.i) annotation(
    Line(points = {{-74, -350}, {-50, -350}}, color = {28, 108, 200}));
  connect(VALVE_1_FITTING_INLET.o, VALVE_1.i) annotation(
    Line(points = {{10, -350}, {40, -350}}, color = {28, 108, 200}));
  connect(VALVE_1.o, VALVE_1_FITTING_OUTLET.i) annotation(
    Line(points = {{60, -350}, {84, -350}}, color = {28, 108, 200}));
  connect(INLET_PIPE_4_OUTLET.o, VALVE_1_FITTING_INLET.i) annotation(
    Line(points = {{-30, -350}, {-10, -350}}, color = {28, 108, 200}));
  connect(INLET_PIPE_5.o, INLET_PIPE_6_INLET.i) annotation(
    Line(points = {{158, -350}, {190, -350}}, color = {28, 108, 200}));
  connect(INLET_PIPE_6_INLET.o, INLET_PIPE_6_BEND.i) annotation(
    Line(points = {{210, -350}, {252, -350}}, color = {28, 108, 200}));
  connect(INLET_PIPE_6_BEND.o, INLET_PIPE_6_OUTLET.i) annotation(
    Line(points = {{272, -350}, {272, -320}}, color = {28, 108, 200}));
  connect(VALVE_2.o, VALVE_2_FITTING_OUTLET.i) annotation(
    Line(points = {{272, -214}, {272, -186}}, color = {28, 108, 200}));
  connect(VALVE_2_FITTING_INLET.o, VALVE_2.i) annotation(
    Line(points = {{272, -256}, {272, -234}}, color = {28, 108, 200}));
  connect(INLET_PIPE_6_OUTLET.o, VALVE_2_FITTING_INLET.i) annotation(
    Line(points = {{272, -300}, {272, -276}}, color = {28, 108, 200}));
  connect(VALVE_2_FITTING_OUTLET.o, PRESSURE_TANK_INLET.i) annotation(
    Line(points = {{272, -166}, {272, -132}}, color = {28, 108, 200}));
  connect(VALVE_1_FITTING_OUTLET.o, INLET_PIPE_5.i) annotation(
    Line(points = {{104, -350}, {138, -350}}, color = {28, 108, 200}));
  connect(PRESSURE_TANK.i, PRESSURE_TANK_INLET.o) annotation(
    Line(points = {{280, -88}, {273, -88}, {273, -112}, {272, -112}}, color = {28, 108, 200}));
  connect(PRESSURE_TANK.o, TOKKE_PIPE_BEND.i) annotation(
    Line(points = {{300, -88}, {314, -88}}, color = {28, 108, 200}));
  connect(TOKKE_PIPE_BEND.o, TOKKE_PIPE.i) annotation(
    Line(points = {{334, -88}, {341, -88}, {341, -110}, {348, -110}}, color = {28, 108, 200}));
  connect(VALVE_3.o, VALVE_3_FITTING_OUTLET.i) annotation(
    Line(points = {{450, -110}, {474, -110}}, color = {28, 108, 200}));
  connect(VALVE_3_FITTING_INLET.o, VALVE_3.i) annotation(
    Line(points = {{412, -110}, {430, -110}}, color = {28, 108, 200}));
  connect(TOKKE_PIPE.o, VALVE_3_FITTING_INLET.i) annotation(
    Line(points = {{368, -110}, {392, -110}}, color = {28, 108, 200}));
  connect(VALVE_3_FITTING_OUTLET.o, ROR_KON1.i) annotation(
    Line(points = {{494, -110}, {514, -110}}, color = {28, 108, 200}));
  connect(FLOWMETER_2_INLET_FITTING.o, FLOWMETER_2.i) annotation(
    Line(points = {{576, -110}, {596, -110}}, color = {28, 108, 200}));
  connect(FLOWMETER_2.o, FLOWMETER_2_OUTLET_FITTING.i) annotation(
    Line(points = {{616, -110}, {636, -110}}, color = {28, 108, 200}));
  connect(ROR_KON1.o, FLOWMETER_2_INLET_FITTING.i) annotation(
    Line(points = {{534, -110}, {556, -110}}, color = {28, 108, 200}));
  connect(FLOWMETER_2_OUTLET_FITTING.o, ROR_KON2.i) annotation(
    Line(points = {{656, -110}, {682, -110}}, color = {28, 108, 200}));
  connect(ROR_KON2.o, ROR_KON3.i) annotation(
    Line(points = {{702, -110}, {722, -110}}, color = {28, 108, 200}));
  connect(KOBLING_INLET.i, ROR_KON3.o) annotation(
    Line(points = {{768, -110}, {742, -110}}, color = {28, 108, 200}));
  connect(KOBLING_INLET.o, KOBLING_INLET_FITTING.i) annotation(
    Line(points = {{788, -110}, {812, -110}}, color = {28, 108, 200}));
  connect(KOBLING_INLET_FITTING.o, KOBLING_OUTLET.i) annotation(
    Line(points = {{832, -110}, {858, -110}}, color = {28, 108, 200}));
  connect(KOBLING_OUTLET.o, ROR_350.i) annotation(
    Line(points = {{878, -110}, {896, -110}}, color = {28, 108, 200}));
  connect(ROR_350.o, ROR_KON4.i) annotation(
    Line(points = {{916, -110}, {940, -110}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.i, INLET_PIPE_1_DOWNWARDS_BEND.o) annotation(
    Line(points = {{-94, 140}, {-112, 140}}, color = {28, 108, 200}));
  connect(UPPER_TANK.o, INLET_PIPE_1_LEFT_BEND.i) annotation(
    Line(points = {{-228, 140}, {-212, 140}, {-212, 140}, {-212, 140}}, color = {28, 108, 200}));
  connect(FLOWMETER_1_INLET_FITTING.i, INLET_PIPE_2_CONICAL_NOZZLE.o) annotation(
    Line(points = {{-94, -10}, {-94, 26}}, color = {28, 108, 200}));
  connect(ramp.y, FRANCIS_TURBINE.u_t) annotation(
    Line(points = {{891, -2}, {1001.5, -2}, {1001.5, -98}, {1002, -98}}, color = {0, 0, 127}));
  connect(ROR_KON4.o, FRANCIS_TURBINE.i) annotation(
    Line(points = {{960, -110}, {992, -110}}, color = {28, 108, 200}));
  connect(FRANCIS_TURBINE.o, SWAMP.o) annotation(
    Line(points = {{1012, -110}, {1026, -110}, {1026, -242}, {1026, -242}}, color = {28, 108, 200}));
  connect(step.y, UPPER_TANK.Level_in) annotation(
    Line(points = {{-268, 146}, {-252, 146}, {-252, 146}, {-250, 146}}, color = {0, 0, 127}));
  annotation(
    Diagram(coordinateSystem(extent = {{-300, -400}, {1100, 200}})),
    Icon(coordinateSystem(extent = {{-300, -400}, {1100, 200}})),
    version="1.0.0",
    versionDate="16.12.20",
    Protection(access = Access.packageDuplicate),
    preferredView="info",
    Documentation(info="<html>
<p> This is the model for the open Francis loop. It does not include pressure propagations in terms of the waterhammer effect. Last updated 16.12.20 </p>
<p> Remember to tick off <i>Enable old frontend for code generation</i> under the tab <i> Translational Flags </i> under <i> Simulation Setup</i>. </p>
</html>"),
  __OpenModelica_commandLineOptions = "--matchingAlgorithm=PFPlusExt --indexReductionMethod=dynamicStateSelection -d=initialization,NLSanalyticJacobian,newInst");

end Open_Francis_Loop;
