within OpenWPL.Tests;

model Closed_Francis_Loop_v1
  extends OpenWPL.Icons.Francis;
  OpenHPL.Waterway.Reservoir UPPER_TANK(H_r = 10, Input_level = true)  annotation(
    Placement(visible = true, transformation(origin = {-234, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp(duration = 0, height = 0.45, offset = 0.5, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {196, 136}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step(height = 0, offset = 10, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {-280, 146}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.ElectroMech.Turbines.Turbine FRANCIS_TURBINE(C_v = 0.5, ConstEfficiency = true, H_n = 12, ValveCapacity = true, Vdot_n = 0.5)  annotation(
    Placement(visible = true, transformation(origin = {312, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-278, 180}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir SWAMP(H_r = 1)  annotation(
    Placement(visible = true, transformation(origin = {370, -12}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe TOKKE_PIPE_BEND(D_i = 0.6, K_L = 0.2)  annotation(
    Placement(visible = true, transformation(origin = {-196, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe TOKKE_PIPE(D_i = 0.6, H = 0.1, L = 2.112)  annotation(
    Placement(visible = true, transformation(origin = {-160, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_3_FITTING_INLET(D_i = 0.6, D_o = 0.602) annotation(
    Placement(visible = true, transformation(origin = {-132, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe VALVE_3(D_i = 0.602, H = 0, L = 0.137) annotation(
    Placement(visible = true, transformation(origin = {-104, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting VALVE_3_FITTING_OUTLET(D_i = 0.602, D_o = 0.566) annotation(
    Placement(visible = true, transformation(origin = {-74, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON1(D_i = 0.566, D_o = 0.250, H = 0, L = 2.833)  annotation(
    Placement(visible = true, transformation(origin = {-42, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting FLOWMETER_2_OUTLET_FITTING(D_i = 0.249, D_o = 0.25) annotation(
    Placement(visible = true, transformation(origin = {46, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting FLOWMETER_2_INLET_FITTING(D_i = 0.25, D_o = 0.249) annotation(
    Placement(visible = true, transformation(origin = {-12, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe FLOWMETER_2(D_i = 0.249, H = 0, L = 0.4) annotation(
    Placement(visible = true, transformation(origin = {16, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON2(D_i = 0.25, D_o = 0.4, H = 0, L = 1.492)  annotation(
    Placement(visible = true, transformation(origin = {74, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON3(D_i = 0.4, D_o = 0.35, H = 0, L = 0.611)  annotation(
    Placement(visible = true, transformation(origin = {106, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe KOBLING_INLET(D_i = 0.35, H = 0, L = 0.185)  annotation(
    Placement(visible = true, transformation(origin = {132, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Fitting KOBLING_INLET_FITTING(D_i = 0.35, D_o = 0.38)  annotation(
    Placement(visible = true, transformation(origin = {162, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe KOBLING_OUTLET(D_i = 0.38, H = 0, L = 0.133)  annotation(
    Placement(visible = true, transformation(origin = {190, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_KON4(D_i = 0.35, D_o = 0.333, H = 0, L = 0.39)  annotation(
    Placement(visible = true, transformation(origin = {258, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe ROR_350(D_i = 0.35, H = 0, L = 3.934) annotation(
    Placement(visible = true, transformation(origin = {224, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(SWAMP.o, FRANCIS_TURBINE.o) annotation(
    Line(points = {{360, -12}, {322, -12}, {322, 56}}, color = {28, 108, 200}));
  connect(ramp.y, FRANCIS_TURBINE.u_t) annotation(
    Line(points = {{207, 136}, {331.5, 136}, {331.5, 68}, {312, 68}}, color = {0, 0, 127}));
  connect(step.y, UPPER_TANK.Level_in) annotation(
    Line(points = {{-269, 146}, {-246, 146}, {-246, 145}}, color = {0, 0, 127}));
  connect(TOKKE_PIPE_BEND.o, TOKKE_PIPE.i) annotation(
    Line(points = {{-186, 80}, {-179, 80}, {-179, 56}, {-170, 56}}, color = {28, 108, 200}));
  connect(VALVE_3.o, VALVE_3_FITTING_OUTLET.i) annotation(
    Line(points = {{-94, 56}, {-84, 56}}, color = {28, 108, 200}));
  connect(VALVE_3_FITTING_INLET.o, VALVE_3.i) annotation(
    Line(points = {{-122, 56}, {-114, 56}}, color = {28, 108, 200}));
  connect(TOKKE_PIPE.o, VALVE_3_FITTING_INLET.i) annotation(
    Line(points = {{-150, 56}, {-142, 56}}, color = {28, 108, 200}));
  connect(VALVE_3_FITTING_OUTLET.o, ROR_KON1.i) annotation(
    Line(points = {{-64, 56}, {-52, 56}}, color = {28, 108, 200}));
  connect(FLOWMETER_2_INLET_FITTING.o, FLOWMETER_2.i) annotation(
    Line(points = {{-2, 56}, {6, 56}}, color = {28, 108, 200}));
  connect(FLOWMETER_2.o, FLOWMETER_2_OUTLET_FITTING.i) annotation(
    Line(points = {{26, 56}, {36, 56}}, color = {28, 108, 200}));
  connect(ROR_KON1.o, FLOWMETER_2_INLET_FITTING.i) annotation(
    Line(points = {{-32, 56}, {-22, 56}}, color = {28, 108, 200}));
  connect(FLOWMETER_2_OUTLET_FITTING.o, ROR_KON2.i) annotation(
    Line(points = {{56, 56}, {64, 56}}, color = {28, 108, 200}));
  connect(ROR_KON2.o, ROR_KON3.i) annotation(
    Line(points = {{84, 56}, {96, 56}}, color = {28, 108, 200}));
  connect(KOBLING_INLET.i, ROR_KON3.o) annotation(
    Line(points = {{122, 56}, {116, 56}}, color = {28, 108, 200}));
  connect(KOBLING_INLET.o, KOBLING_INLET_FITTING.i) annotation(
    Line(points = {{142, 56}, {152, 56}}, color = {28, 108, 200}));
  connect(KOBLING_INLET_FITTING.o, KOBLING_OUTLET.i) annotation(
    Line(points = {{172, 56}, {180, 56}}, color = {28, 108, 200}));
  connect(ROR_KON4.o, FRANCIS_TURBINE.i) annotation(
    Line(points = {{268, 56}, {302, 56}}, color = {28, 108, 200}));
  connect(KOBLING_OUTLET.o, ROR_350.i) annotation(
    Line(points = {{200, 56}, {214, 56}}, color = {28, 108, 200}));
  connect(ROR_350.o, ROR_KON4.i) annotation(
    Line(points = {{234, 56}, {248, 56}}, color = {28, 108, 200}));
  connect(UPPER_TANK.o, TOKKE_PIPE_BEND.i) annotation(
    Line(points = {{-224, 140}, {-206, 140}, {-206, 80}}, color = {28, 108, 200}));
  annotation(
    Diagram(coordinateSystem(extent = {{-300, -200}, {800, 200}})),
    Icon(coordinateSystem(extent = {{-300, -200}, {800, 200}})));
end Closed_Francis_Loop_v1;
