within OpenWPL.Tests;

model Open_Francis_Loop_v2
  extends OpenWPL.Icons.Francis;
  OpenHPL.Waterway.Reservoir upper_tank(H_r = 10, Input_level = true, L = 50, alpha = 0, w = 10)  annotation(
    Placement(visible = true, transformation(origin = {-410, 482}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP test_section(D_i = 0.4, H = 42, L = 60, PipeElasticity = true, h_s0 = 5)  annotation(
    Placement(visible = true, transformation(origin = {-212, 456}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir pressure_tank(H_r = 5, L = 20, w = 10)  annotation(
    Placement(visible = true, transformation(origin = {-148, 456}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-488, 488}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step(height = 12, offset = 10, startTime = 25)  annotation(
    Placement(visible = true, transformation(origin = {-452, 486}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_LEFT_BEND(D_i = 0.5, K_L = 0.3)  annotation(
    Placement(visible = true, transformation(origin = {-376, 482}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_DOWNWARDS_BEND(D_i = 0.5, K_L = 0.2)  annotation(
    Placement(visible = true, transformation(origin = {-312, 482}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_2_CONICAL_DIFFUSER(D_i = 0.5, D_o = 0.6, H = 0.545, L = 0.545, PipeElasticity = true, h_s0 = 2, vertical = false)  annotation(
    Placement(visible = true, transformation(origin = {-302, 430}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_2_INLET_SECTION(D_i = 0.5, H = 0.825, L = 1.365, PipeElasticity = true, h_s0 = 1)  annotation(
    Placement(visible = true, transformation(origin = {-346, 482}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_2_MIDDLE_SECTION(D_i = 0.6, H = 1.763, L = 1.763, PipeElasticity = true, h_s0 = 3)  annotation(
    Placement(visible = true, transformation(origin = {-302, 382}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_2_CONICAL_NOZZLE(D_i = 0.6, D_o = 0.4, H = 0.880, L = 0.880, PipeElasticity = true, h_s0 = 4)  annotation(
    Placement(visible = true, transformation(origin = {-302, 346}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
equation
  connect(pressure_tank.o, test_section.o) annotation(
    Line(points = {{-158, 456}, {-202, 456}}, color = {28, 108, 200}));
  connect(upper_tank.o, INLET_PIPE_1_LEFT_BEND.i) annotation(
    Line(points = {{-400, 482}, {-386, 482}}, color = {28, 108, 200}));
  connect(step.y, upper_tank.Level_in) annotation(
    Line(points = {{-441, 486}, {-424, 486}, {-424, 488}, {-422, 488}}, color = {0, 0, 127}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.o, INLET_PIPE_2_MIDDLE_SECTION.i) annotation(
    Line(points = {{-302, 420}, {-302, 392}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_MIDDLE_SECTION.o, INLET_PIPE_2_CONICAL_NOZZLE.i) annotation(
    Line(points = {{-302, 372}, {-302, 356}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1_LEFT_BEND.o, INLET_PIPE_2_INLET_SECTION.i) annotation(
    Line(points = {{-366, 482}, {-356, 482}, {-356, 482}, {-356, 482}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_INLET_SECTION.o, INLET_PIPE_1_DOWNWARDS_BEND.i) annotation(
    Line(points = {{-336, 482}, {-322, 482}, {-322, 482}, {-322, 482}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1_DOWNWARDS_BEND.o, INLET_PIPE_2_CONICAL_DIFFUSER.i) annotation(
    Line(points = {{-302, 482}, {-302, 440}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_NOZZLE.o, test_section.i) annotation(
    Line(points = {{-302, 336}, {-222, 336}, {-222, 456}, {-222, 456}}, color = {28, 108, 200}));
  annotation(
    __OpenModelica_commandLineOptions = "--matchingAlgorithm=PFPlusExt --indexReductionMethod=dynamicStateSelection -d=initialization,NLSanalyticJacobian",
    Diagram(coordinateSystem(extent = {{-500, -500}, {500, 500}})),
    Icon(coordinateSystem(extent = {{-500, -500}, {500, 500}})),
  experiment(StartTime = 0, StopTime = 200, Tolerance = 1e-6, Interval = 0.4),
  __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));

end Open_Francis_Loop_v2;
