within OpenWPL.Tests;

model Open_Francis_Loop_v3
  extends OpenWPL.Icons.Francis;
  Modelica.Blocks.Sources.Step step(height = 10, offset = 10, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {-258, 234}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_LEFT_BEND(D_i = 0.5, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {-180, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir UPPER_TANK(H_r = 10,Input_level = true, L = 10, w = 10) annotation(
    Placement(visible = true, transformation(origin = {-212, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_1(D_i = 0.5, H = 1.365, L = 1.365, PipeElasticity = true, h_s0 = 10)  annotation(
    Placement(visible = true, transformation(origin = {-148, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_DOWNWARDS_BEND(D_i = 0.5, K_L = 1)  annotation(
    Placement(visible = true, transformation(origin = {-108, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.ElectroMech.Turbines.Turbine turbine(C_v = 0.5,ConstEfficiency = true, H_n = 11.9, ValveCapacity = false, Vdot_n = 0.5, WaterCompress = true)  annotation(
    Placement(visible = true, transformation(origin = {-6, 158}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp(duration = 5, height = 0.45, offset = 0.5, startTime = 100)  annotation(
    Placement(visible = true, transformation(origin = {-58, 208}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir reservoir(H_r = 0)  annotation(
    Placement(visible = true, transformation(origin = {30, 158}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP INLET_PIPE_2_CONICAL_DIFFUSER(D_i = 0.5, D_o = 0.6, H = 0.535, L = 0.535, PipeElasticity = true, h_s0 = 11.365)  annotation(
    Placement(visible = true, transformation(origin = {-98, 168}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-258, 204}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(step.y, UPPER_TANK.Level_in) annotation(
    Line(points = {{-247, 234}, {-224, 234}, {-224, 235}}, color = {0, 0, 127}));
  connect(ramp.y, turbine.u_t) annotation(
    Line(points = {{-47, 208}, {-6, 208}, {-6, 170}}, color = {0, 0, 127}));
  connect(UPPER_TANK.o, INLET_PIPE_1_LEFT_BEND.i) annotation(
    Line(points = {{-202, 230}, {-190, 230}, {-190, 230}, {-190, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1_LEFT_BEND.o, INLET_PIPE_1.i) annotation(
    Line(points = {{-170, 230}, {-158, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1.o, INLET_PIPE_1_DOWNWARDS_BEND.i) annotation(
    Line(points = {{-138, 230}, {-118, 230}}, color = {28, 108, 200}));
  connect(turbine.o, reservoir.o) annotation(
    Line(points = {{4, 158}, {20, 158}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.i, INLET_PIPE_1_DOWNWARDS_BEND.o) annotation(
    Line(points = {{-98, 178}, {-98, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.o, turbine.i) annotation(
    Line(points = {{-98, 158}, {-16, 158}}, color = {28, 108, 200}));
protected
  annotation(
    Diagram(coordinateSystem(extent = {{-300, -300}, {300, 300}})),
    Icon(coordinateSystem(extent = {{-300, -300}, {300, 300}})));
end Open_Francis_Loop_v3;
