within OpenWPL.Tests;

model Open_Francis_Loop_v4
  extends OpenWPL.Icons.Francis;
  Modelica.Blocks.Sources.Step step(height = 10, offset = 10, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {-84, 84}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir PRESSURE_TANK annotation(
    Placement(visible = true, transformation(origin = {80, -58}, extent = {{-10, -10}, {10, 10}}, rotation = 180)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_LEFT_BEND(D_i = 0.5, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {-14, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir UPPER_TANK(Input_level = true, L = 10, w = 10) annotation(
    Placement(visible = true, transformation(origin = {-44, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-84, 52}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_DOWNWARDS_BEND(D_i = 0.5, K_L = 1)  annotation(
    Placement(visible = true, transformation(origin = {60, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_1(D_i = 0.5, H = 1.365, L = 1.365)  annotation(
    Placement(visible = true, transformation(origin = {14, 78}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Pipe INLET_PIPE_2_CONICAL_DIFFUSER(D_i = 0.5, H = 10, L = 10)  annotation(
    Placement(visible = true, transformation(origin = {70, 10}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
equation
  connect(step.y, UPPER_TANK.Level_in) annotation(
    Line(points = {{-72, 84}, {-58, 84}, {-58, 84}, {-56, 84}}, color = {0, 0, 127}));
  connect(UPPER_TANK.o, INLET_PIPE_1_LEFT_BEND.i) annotation(
    Line(points = {{-34, 78}, {-24, 78}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1.i, INLET_PIPE_1_LEFT_BEND.o) annotation(
    Line(points = {{4, 78}, {-4, 78}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1.o, INLET_PIPE_1_DOWNWARDS_BEND.i) annotation(
    Line(points = {{24, 78}, {24, 77}, {50, 77}, {50, 78}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.o, PRESSURE_TANK.o) annotation(
    Line(points = {{70, 0}, {70, -58}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.i, INLET_PIPE_1_DOWNWARDS_BEND.o) annotation(
    Line(points = {{70, 20}, {70, 78}}, color = {28, 108, 200}));
end Open_Francis_Loop_v4;
