within OpenWPL.Tests;

model Open_Francis_Loop_v5
  extends OpenWPL.Icons.Francis;
  Modelica.Blocks.Sources.Step step(height = 10, offset = 10, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {-258, 234}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_LEFT_BEND(D_i = 0.5, K_L = 1.1)  annotation(
    Placement(visible = true, transformation(origin = {-180, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir UPPER_TANK(H_r = 10,Input_level = true, L = 10, w = 10) annotation(
    Placement(visible = true, transformation(origin = {-212, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-258, 204}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.BendPipe INLET_PIPE_1_DOWNWARDS_BEND(D_i = 0.5, K_L = 1)  annotation(
    Placement(visible = true, transformation(origin = {-108, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.ElectroMech.Turbines.Turbine turbine annotation(
    Placement(visible = true, transformation(origin = {-6, 150}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp(duration = 0)  annotation(
    Placement(visible = true, transformation(origin = {66, 208}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir reservoir annotation(
    Placement(visible = true, transformation(origin = {28, 150}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Penstock INLET_PIPE_1(D_i = 0.5, D_o = 0.5,H = 1.365, L = 1.365)  annotation(
    Placement(visible = true, transformation(origin = {-144, 230}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Penstock INLET_PIPE_2_CONICAL_DIFFUSER(D_i = 0.5, D_o = 0.6, H = 0.535, L = 0.535)  annotation(
    Placement(visible = true, transformation(origin = {-100, 160}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
equation
  connect(step.y, UPPER_TANK.Level_in) annotation(
    Line(points = {{-247, 234}, {-224, 234}, {-224, 235}}, color = {0, 0, 127}));
  connect(ramp.y, turbine.u_t) annotation(
    Line(points = {{77, 208}, {-6, 208}, {-6, 162}}, color = {0, 0, 127}));
  connect(UPPER_TANK.o, INLET_PIPE_1_LEFT_BEND.i) annotation(
    Line(points = {{-202, 230}, {-190, 230}, {-190, 230}, {-190, 230}}, color = {28, 108, 200}));
  connect(turbine.o, reservoir.o) annotation(
    Line(points = {{4, 150}, {18, 150}, {18, 150}, {18, 150}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1_LEFT_BEND.o, INLET_PIPE_1.i) annotation(
    Line(points = {{-170, 230}, {-154, 230}, {-154, 230}, {-154, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_1.o, INLET_PIPE_1_DOWNWARDS_BEND.i) annotation(
    Line(points = {{-134, 230}, {-118, 230}, {-118, 230}, {-118, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.i, INLET_PIPE_1_DOWNWARDS_BEND.o) annotation(
    Line(points = {{-100, 170}, {-100, 230}, {-98, 230}}, color = {28, 108, 200}));
  connect(INLET_PIPE_2_CONICAL_DIFFUSER.o, turbine.i) annotation(
    Line(points = {{-100, 150}, {-16, 150}}, color = {28, 108, 200}));
protected
  annotation(
    Diagram(coordinateSystem(extent = {{-300, -300}, {300, 300}})),
    Icon(coordinateSystem(extent = {{-300, -300}, {300, 300}})));

end Open_Francis_Loop_v5;
