within OpenWPL.Tests;

model Open_Francis_Loop_v9
  extends OpenWPL.Icons.Francis;
  OpenHPL.Waterway.PenstockKP ROR_KON4(D_i = 3.5, H = 1000, L = 39, PipeElasticity = true, h_s0 = 4)  annotation(
    Placement(visible = true, transformation(origin = {-12, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir reservoir(H_r = 4.1391, Input_level = false, L = 2, alpha = 0, w = 2)  annotation(
    Placement(visible = true, transformation(origin = {-68, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.ElectroMech.Turbines.Turbine turbine(C_v = 0.5, ConstEfficiency = true, H_n = 12, ValveCapacity = true, Vdot_n = 2.5)  annotation(
    Placement(visible = true, transformation(origin = {14, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.Reservoir reservoir1(H_r = 1)  annotation(
    Placement(visible = true, transformation(origin = {62, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 180)));
  Modelica.Blocks.Sources.Step step(height = 0, offset = 10, startTime = 25)  annotation(
    Placement(visible = true, transformation(origin = {-82, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp(duration = 1, height = 0.45, offset = 0.5, startTime = 50)  annotation(
    Placement(visible = true, transformation(origin = {-2, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner OpenHPL.Data data annotation(
    Placement(visible = true, transformation(origin = {-62, 88}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenHPL.Waterway.PenstockKP penstockKP(D_i = 3.5, H = 10, L = 39, PipeElasticity = true, h_s0 = 4) annotation(
    Placement(visible = true, transformation(origin = {-40, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Pipes.StaticPipe pipe annotation(
    Placement(visible = true, transformation(origin = {-72, -48}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Pipes.DynamicPipe pipe1 annotation(
    Placement(visible = true, transformation(origin = {-8, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(ROR_KON4.o, turbine.i) annotation(
    Line(points = {{-2, -2}, {4, -2}}, color = {28, 108, 200}));
  connect(turbine.o, reservoir1.o) annotation(
    Line(points = {{24, -2}, {52, -2}}, color = {28, 108, 200}));
  connect(ramp.y, turbine.u_t) annotation(
    Line(points = {{10, 50}, {14, 50}, {14, 10}, {14, 10}}, color = {0, 0, 127}));
  connect(step.y, reservoir.Level_in) annotation(
    Line(points = {{-70, 56}, {-80, 56}, {-80, 4}, {-80, 4}}, color = {0, 0, 127}));
  connect(penstockKP.o, ROR_KON4.i) annotation(
    Line(points = {{-30, -2}, {-22, -2}}, color = {28, 108, 200}));
  connect(reservoir.o, penstockKP.i) annotation(
    Line(points = {{-58, -2}, {-50, -2}}, color = {28, 108, 200}));
end Open_Francis_Loop_v9;
