within OpenWPL.Tests;

model Pipe_test_v5
    extends OpenWPL.Icons.Pipe;
	//inner declarations (global variables and constants)
	inner Modelica.Fluid.System system(
	  allowFlowReversal = false, 
	  energyDynamics = Modelica.Fluid.Types.Dynamics.FixedInitial)     
	  annotation(
	Placement(transformation(extent={{60,60},{80,80}})));
	inner OpenWPL.MOC moc 
	  annotation(
	  Placement(visible = true, transformation(origin = {48, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

	//medium declarations
	replaceable package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater 
	  constrainedby Modelica.Media.Interfaces.PartialMedium "Medium in the component";
	//upper tank
	Modelica.Fluid.Vessels.OpenTank Source(
	  redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
	  nPorts= 1,
	  crossArea=1,
	  level_start=1,
	  portsData={Modelica.Fluid.Vessels.BaseClasses.VesselPortsData(diameter=0.1)},
	  height=1.1)  
	  annotation(
	  Placement(visible = true, transformation(origin = {-62, 4}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
	//pipe between tanks
	OpenWPL.Components.Pipe_MSL_v4 pipe(
	  redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater, allowFlowReversal = false,
	  diameter=0.1,
	  height_ab=-1,
	  length=1)
	  annotation(
	  Placement(visible = true, transformation(origin = {-8, -16}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
	//lower tank
	Modelica.Fluid.Vessels.OpenTank Sink(
	  
	  redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,crossArea=1,
	  height=1.1,
	  level_start=1.0e-10,
	  nPorts= 1,
	  portsData={Modelica.Fluid.Vessels.BaseClasses.VesselPortsData(diameter=0.1, height=0.5)})  
	  annotation(
	  Placement(visible = true, transformation(origin = {46, 4}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
	equation
	connect(Source.ports[1], pipe.port_a) annotation(
	  Line(points = {{-62, -16}, {-18, -16}, {-18, -16}, {-18, -16}}, color = {0, 127, 255}));
	connect(pipe.port_b, Sink.ports[1]) annotation(
	  Line(points = {{2, -16}, {40, -16}, {40, -16}, {46, -16}}, color = {0, 127, 255}));

protected
	annotation(
	  __OpenModelica_commandLineOptions = "--matchingAlgorithm=PFPlusExt --indexReductionMethod=dynamicStateSelection -d=initialization,NLSanalyticJacobian,newInst",
	  Diagram);


end Pipe_test_v5;

