package OpenWPL
  extends Icons.Logo;
  import C = Modelica.Constants;
  import SI = Modelica.SIunits;

  annotation (
    version="1.0.0",
    versionDate="16.12.20",
    Protection(access = Access.packageDuplicate),
    preferredView="info",
    Documentation(info="<html>
<p>The OpenWPL is an open-source hydropower library that
consists of models from the <a href=\"https://www.ntnu.edu/ept/laboratories/waterpower#/view/about\">Waterpower Laboratory</a>. </p> Parts of the library is modelled using Modelica, and uses the open-source hydropower library OpenHPL developed at the <a href=\"https://www.usn.no/english\">University of South-Eastern Norway (USN)</a>, Campus Porsgrunn. OpenHPL must consequently be loaded whenever OpenWPL is to be used.</p>
<p> The models are made by Jonas Tveit Hinna in accordance with his project work at the Norwegian University of Science and Technology. The library was further developed in the following master's thesis.</p>
<p> The models that can be simulated is located in the package Rigs.</p>
</html>"),
  Icon);
end OpenWPL;
